"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const d3_axis_1 = require("d3-axis");
const d3_selection_1 = require("d3-selection");
const react_1 = __importStar(require("react"));
const hooks_1 = require("../hooks");
const YAxis = ({ label, fontSize = 16, showGridLines, labelStyle, }) => {
    const axisRef = react_1.useRef(null);
    const { yScale, margin, height, width } = hooks_1.usePlotContext();
    react_1.useEffect(() => {
        if ((axisRef === null || axisRef === void 0 ? void 0 : axisRef.current) && yScale) {
            const axis = d3_axis_1.axisLeft(yScale);
            if (showGridLines) {
                axis.tickSizeInner(((margin === null || margin === void 0 ? void 0 : margin.left) || 0) + ((margin === null || margin === void 0 ? void 0 : margin.right) || 0) - width);
            }
            d3_selection_1.select(axisRef.current)
                .call(axis)
                .call((g) => {
                g.selectAll('.tick line')
                    .attr('stroke-opacity', showGridLines ? 0.5 : 1)
                    .attr('stroke-dasharray', showGridLines ? '2,2' : '0');
                g.selectAll('.tick text').attr('transform', `translate(${showGridLines ? -6 : 0},0)`);
            });
        }
    }, [axisRef, yScale, margin, width, showGridLines]);
    // Recomend bigger margin
    if (((margin === null || margin === void 0 ? void 0 : margin.bottom) || 0) < fontSize + 30) {
        // eslint-disable-next-line no-console
        console.warn(`Your margin bottom should be at least ${fontSize + 30}`);
    }
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("g", { ref: axisRef, transform: `translate(${(margin === null || margin === void 0 ? void 0 : margin.left) || 0}, 0)` }),
        label && (react_1.default.createElement("text", { transform: `translate(${((margin === null || margin === void 0 ? void 0 : margin.left) || 0) - fontSize - 30}, ${height / 2})rotate(-90)`, dy: fontSize, textAnchor: "middle", fontSize: fontSize, style: { fontFamily: 'Arial, Helvetica, sans-serif', ...labelStyle } }, label))));
};
exports.default = YAxis;
