"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.splitChildren = exports.getNextId = void 0;
const react_1 = __importDefault(require("react"));
const Heading_1 = __importDefault(require("./components/Heading"));
const Legend_1 = __importDefault(require("./components/Legend"));
const LineSeries_1 = __importDefault(require("./components/LineSeries"));
const XAxis_1 = __importDefault(require("./components/XAxis"));
const YAxis_1 = __importDefault(require("./components/YAxis"));
let currentValue = 1;
function getNextId() {
    return ++currentValue;
}
exports.getNextId = getNextId;
function splitChildren(children) {
    let invalidChild = false;
    let lineSeries = [];
    let axis = { x: null, y: null };
    let heading = null;
    let legend = null;
    for (let child of react_1.default.Children.toArray(children)) {
        // Base child validation
        if (typeof child !== 'object' || !react_1.default.isValidElement(child)) {
            invalidChild = true;
        }
        // Classifies the expected components
        else if (child.type === LineSeries_1.default) {
            lineSeries.push(child);
        }
        else if (child.type === XAxis_1.default) {
            axis.x = child;
        }
        else if (child.type === YAxis_1.default) {
            axis.y = child;
        }
        else if (child.type === Heading_1.default) {
            heading = child;
        }
        else if (child.type === Legend_1.default) {
            legend = child;
        }
        // Default case
        else {
            invalidChild = true;
        }
    }
    return { invalidChild, lineSeries, axis, heading, legend };
}
exports.splitChildren = splitChildren;
